library(iForecast)
library(timeSeries)
print(load("./data/us_cpi.RData"))
dep=na.omit(diff(log(us_cpi),12))*100

type=c("none","trend","season","both")[1]
train.end="2019-12-01"
test.start="2020-01-01"
LSTM=ttsLSTM(y=dep, x=NULL, train.end,arOrder=c(1:12), xregOrder=c(0), memoryLoops=25, type=type)
testData=window(LSTM$data,start=test.start,end=end(LSTM$data))
P1=iForecast(Model=LSTM, newdata=testData, type="staticfit")
P2=iForecast(Model=LSTM, newdata=testData, type="recursive")
cbind(testData[,1],P1,P2)



trainData=window(LSTM$dataused,start=start(LSTM$dataused),end=train.end)
P0=iForecast(Model=LSTM, newdata=trainData, type="staticfit")
sample0=cbind(actual=trainData[,1],pred=P0)
sample1=cbind(actual=testData[,1],pred=P1)
newDataX=rbind(sample0, sample1)
rownames(newDataX)=c(rownames(P0),rownames(testData))
newDataX=as.timeSeries(newDataX)
MAIN1=paste0(MAIN.dm," with memory loops=",memoryLoops)
t0=which(as.character(time(newDataX))==train.end)
dev.new()
plot(newDataX[,1],ylim=range(newDataX),main="",ylab="",xlab="Static Forecasts",lty = 1)
lines(newDataX[,2],ylim=range(newDataX), col="red", pch=1,type="o",lty = 2)
legend("topleft", legend=c("Actual Data","Static forecast"),text.col=c("black","red"),pch=c(NA,1),lty=c(1,2))
abline(h=0,v=as.POSIXct(test.start),col="blue");grid()
text(as.POSIXct(rownames(newDataX)[t0-20]), max(dep)*0.9, test.start,col="blue")
