print(load("mainData.RData"))
names(dataset)
usedData0=dataset[,c(1:23)][,-c(16,18)] #Use USD_million for IMPORT/EXPORT
names(usedData0)


usedData1=na.omit(cbind(usedData0[-c(1:12),1:4],diff(log(usedData0[,-c(1:4,14)]),12)*100,usedData0[,14]))
Y=usedData1[,1:4]
usedData=usedData1[,-c(1:4)]
head(usedData)
N=ncol(usedData)

data0=as.data.frame(usedData)
.PC_corr = princomp(as.matrix(data0), cor = T, scores = T)  
sigma_corr=(summary(.PC_corr, loadings=TRUE)$sdev)^2
varianceRatio_corr=t(round(sigma_corr/sum(sigma_corr),4))
cumsum(varianceRatio_corr)
summary(.PC_corr, loadings=TRUE)
summary(.PC_corr, loadings=TRUE)$scores

PCA.corr=.PC_corr$scores[,c(1:N)]
colnames(PCA.corr)=paste0("PCA",1:N)
PCA.corr=timeSeries::as.timeSeries(PCA.corr,time(usedData))

library(FactoMineR)
library(factoextra)
eig.val <- get_eigenvalue(.PC_corr) #eigenvalues越大，對變異數解釋的貢獻越大
eig.val
MAX2=as.integer(max(eig.val[,2])*1.1)
MAX3=as.integer(max(eig.val[,3])*1.1)

A=fviz_eig(.PC_corr, addlabels = TRUE, ylim = c(0, MAX2),ncp = 10,main="Scree plot of variance proportion, Corr=TRUE")
B=fviz_eigAccumulated(.PC_corr, addlabels = TRUE, ylim = c(0, MAX3*1.1),ncp = 10,main="Scree plot of variance accumulation, Corr=TRUE") 

dev.new();ggpubr::ggarrange(A, B,#labels = c("Proportion", "Cummulated"),
          ncol = 1, nrow = 2)


#screeplot(.PC_corr, type = "barplot")

.PC.noCorr = princomp(as.matrix(data0), cor = F, scores = T) 
summary(.PC.noCorr, loadings=TRUE)
sigma=(summary(.PC.noCorr, loadings=TRUE)$sdev)^2
varianceRatio=t(round(sigma/sum(sigma),4))
cumsum(varianceRatio)

n=as.integer(sqrt(N))
PCA.noCorr=.PC$scores[,c(1:n)]
colnames(PCA.noCorr)=paste0("PCA",1:n)
PCA.noCorr=timeSeries::as.timeSeries(PCA.noCorr,time(usedData))

eig.val.noCorr <- get_eigenvalue(.PC.noCorr) #eigenvalues越大，對變異數解釋的貢獻越大
eig.val.noCorr
MAX2.noCorr=as.integer(max(eig.val.noCorr[,2])*1.1)
MAX3.noCorr=as.integer(max(eig.val.noCorr[,3])*1.1)

A.noCorr=fviz_eig(.PC.noCorr, addlabels = TRUE, ylim = c(0, MAX2.noCorr),ncp = 10,main="Scree plot of variance proportion, Corr=FALSE")
B.noCorr=fviz_eigAccumulated(.PC.noCorr, addlabels = TRUE, ylim = c(0, MAX3.noCorr*1.1),ncp = 10,main="Scree plot of variance accumulation, Corr=FALSE") 

dev.new();ggpubr::ggarrange(A.noCorr, B.noCorr,#labels = c("Proportion", "Cummulated"),
                            ncol = 1, nrow = 2)







require(fastICA)
seed(12345)
ICA_result = fastICA(data0, n.comp = 12)

# 以下就是ICA萃取出的來源 
ICA = ICA_result$S
n.ICA=ncol(ICA)
colnames(ICA)=paste0("ICA",1:n.ICA)
ICA=timeSeries::as.timeSeries(ICA,time(usedData))
dev.new();plot(ICA[,1:6],main="")
dev.new();plot(ICA[,7:n.ICA],main="")

ICA=cbind(Y,ICA)
PCA.noCorr=cbind(Y,PCA.noCorr)
PCA.corr=cbind(Y,PCA.corr)

save(ICA,PCA.corr, PCA.noCorr, file="./data/Components.RData")

ica.name=colnames(ICA)
pValue=NULL
for (i in ica.name) {
  pValue=c(pValue,cor.test(Y[,1],ICA[,i])$p.value)

}
which(pValue<=0.05)

icaData=data.frame(y=as.factor(Y[,1]),ICA)
rownames(icaData)=NULL
Eq=as.formula(paste("y", paste(ica.name,collapse = "+"),sep="~"))
ID=which(round(coef(summary(glm(Eq,data=icaData,family = binomial(link="logit"))))[-1,4],4)<0.02)
dev.new();plot(ICA[,ID[1:6]],main="ICA for P-value < 0.02",xlab="")

fviz_eigAccumulated <- function (X, choice = c("variance", "eigenvalue"), 
          geom = c("bar", "line"), barfill = "steelblue", 
          barcolor = "steelblue", linecolor = "black", 
          ncp = 10, addlabels = FALSE, hjust = 0, main = NULL, xlab = NULL, 
          ylab = NULL, ggtheme = theme_minimal(), ...) {
  eig <- get_eigenvalue(X)
  eig <- eig[1:min(ncp, nrow(eig)), , drop = FALSE]
  choice <- choice[1]
  if (choice == "eigenvalue") {
    eig <- eig[, 1]
    text_labels <- round(eig, 1)
    if (is.null(ylab)) 
      ylab <- "Eigenvalue"
  }
  else if (choice == "variance") {
    eig <- eig[, 3]
    text_labels <- paste0(round(eig, 1), "%")
  }
  else stop("Allowed values for the argument choice are : 'variance' or 'eigenvalue'")
  if (length(intersect(geom, c("bar", "line"))) == 
      0) 
    stop("The specified value(s) for the argument geom are not allowed ")
  df.eig <- data.frame(dim = factor(1:length(eig)), eig = eig)
  extra_args <- list(...)
  bar_width <- extra_args$bar_width
  linetype <- extra_args$linetype
  if (is.null(linetype)) 
    linetype <- "solid"
  p <- ggplot(df.eig, aes(dim, eig, group = 1))
  if ("bar" %in% geom) 
    p <- p + geom_bar(stat = "identity", fill = barfill, 
                      color = barcolor, width = bar_width)
  if ("line" %in% geom) 
    p <- p + geom_line(color = linecolor, linetype = linetype) + 
    geom_point(shape = 19, color = linecolor)
  if (addlabels) 
    p <- p + geom_text(label = text_labels, vjust = -0.4, 
                       hjust = hjust)
  if (is.null(main)) 
    main <- "Scree plot"
  if (is.null(xlab)) 
    xlab <- "Dimensions"
  if (is.null(ylab)) 
    ylab <- "Percentage of explained variances"
  p <- p + labs(title = main, x = xlab, y = ylab)
  ggpubr::ggpar(p, ggtheme = ggtheme, ...)
}