outputPath="./output/data/"
library(caret)
library(timeSeries)
y0=paste0("transition",c(0,2:4))[1]
y2=paste0("transition",c(0,2:4))[2]
y3=paste0("transition",c(0,2:4))[3]
y4=paste0("transition",c(0,2:4))[4]
print(load("./data/mainData.RData"))
howmany=which(names(dataset)=="C112")
removal=grep(colnames(dataset),pattern="NTD_million")
dataset=na.omit(dataset[,1:howmany])[,-c(removal)]
dim(dataset)
head(dataset)

keepLevelID1=c(grep("risk",colnames(dataset)),grep("Unemp",colnames(dataset)),grep("Turnover",colnames(dataset)))
  
usedData0=dataset[,-keepLevelID1]
names(usedData0)

usedData=na.omit(cbind(usedData0[-c(1:12),y0],diff(log(usedData0[,-c(1:4)]),12)*100,dataset[-c(1:12),keepLevelID1]))
dim(usedData)
p=6
timeID=time(usedData)[-c(1:p)]
embedY=as.timeSeries(embed(usedData[,1,drop=F],p+1),timeID)

embedX=as.timeSeries(embed(usedData[,-1],p+1),timeID)
LX.names=c(outer(paste0(colnames(usedData)[-1],"_L"),0:p,FUN=paste0))
colnames(embedX)=LX.names

dep=embedY[,1]

#m=1;Type=2
data.name="raw"
dir=c("glm","svmRadial","rpart","rf")[m] 
TYPE=c("none","season_trend")[Type] # Whether season and trend are specified


Future_byT=PM.train_byT=PM.test_byT=NULL
predData_byT=list()
Future_byT=PM.train_byT=PM.test_byT=NULL; predData_byT=list()
for (t0 in 1:length(TO)) { 

  COLNAMES=paste0(LX.simpleID,"_t",t0)


  trainData0=window(trainingSample,start=FROM[1],end=TO[t0])


  if(t0==length(TO)) {
  validationData0=window(trainingSample, start=TO[t0],end=end(trainingSample))[-1,]
      } else {validationData0=window(trainingSample, start=TO[t0], end=TO[t0+1])}
  if (nrow(validationData0)<25) {next}
  
  trainData=as.data.frame(unclass(trainData0))
  validationData=as.data.frame(unclass(validationData0))
  
  trainData$y=as.factor(trainData$y)
  validationData$y=as.factor(validationData$y)
  

  output=train(Formula, data=trainData, method=dir, tuneLength = 20)


  Pred1 =as.integer(predict(output,trainData,type=c("raw","prob")[1]))-1
 
if (sum(Pred1)==0 || sum(Pred1)==length(Pred1)) {Pred1[length(Pred1)]=1-Pred1[length(Pred1)]}

 CFMatrix1=table(actual = trainData[,"y"], predicted =as.factor(Pred1))  


  confusionMatrix(CFMatrix1)
  
  Pred2 =as.integer(predict(output,validationData,type=c("raw","prob")[1]))-1
    if (sum(Pred2)==0 || sum(Pred2)==length(Pred2)) {Pred2[length(Pred2)]=1-Pred2[length(Pred2)]}
    actual=as.integer(validationData[,"y"])-1
    if (sum(actual)==0 || sum(actual)==length(actual)) {actual[length(actual)]=1-actual[length(actual)]}
    CFMatrix2=table(actual = actual, predicted =as.factor(Pred2))  #Confusion matrix
  confusionMatrix(CFMatrix2)
  
  PM.train0=round(rbind(as.matrix(confusionMatrix(CFMatrix1),what="overall"),
                        as.matrix(confusionMatrix(CFMatrix1),what="classes")),3)
  colnames(PM.train0)=COLNAMES
  PM.train_byT=cbind(PM.train_byT,PM.train0)
  
  PM.test0=round(rbind(as.matrix(confusionMatrix(CFMatrix2),what="overall"),
                       as.matrix(confusionMatrix(CFMatrix2),what="classes")),3)
  colnames(PM.test0)=COLNAMES
  PM.test_byT=cbind(PM.test_byT,PM.test0)
  
  predData0=data.frame(actual = validationData[,"y"], predict =as.factor(Pred2))
  rownames(predData0)=as.character(time(validationData0))
  predData_byT[[t0]]=predData0
  
  print(paste0(output$method," ",TYPE," ",COLNAMES))
  

  future =as.integer(predict(output, testData,type=c("raw","prob")[1]))-1
  future=as.timeSeries(future, time(testData))
  colnames(future)=COLNAMES
  Future_byT=cbind(Future_byT,future)
  
  } #End of t0 loop for rolling
  
  savedRData_byT=paste0(outputPath,data.name,"/",output$method,"/",TYPE,"/",LX.simpleID,".RData")
  savedRData.all=paste0(outputPath,data.name,"/",output$method,"/",TYPE,"/","_PM_all.RData")
  
  save(Future_byT,PM.train_byT,PM.test_byT,predData_byT,file=savedRData_byT)
  
  PM.train.all=cbind(PM.train.all,PM.train_byT)
  PM.test.all=cbind(PM.test.all,PM.test_byT)
  Future.all=cbind(Future.all,Future_byT)
  
}#End of L loop


save(PM.train.all,PM.test.all,Future.all,file=savedRData.all) 

