library(gplots)
path="./output/data/"

d=1
datasetName=c("raw data", "ICA data", "PCA data by correlation","PCA data by covariance")[d]
XLAB=paste0("Models used to train ", datasetName)
dataset=c("raw/","ICA/","PCA.corr/","PCA.noCorr/")[d]
type=c("none/","season_trend/")[2]

i=1
ID=c("Accuracy","Kappa","F1","Precision","Recall")[i]
MAIN=paste0("Performance index: ", ID)

      ACC=NULL;for (j in 1:4) {#j=1
      model0=c("glm/","svmRadial/", "rpart/","rf/")[j]
      model=paste0(dataset,model0)
      
      Path=paste0(path,model,type)
      filenames=list.files(Path)
      file=paste0(Path,filenames[1])
      load(file)
      #ID=which(PM.test.all[1,]==max(PM.test.all[1,]));ID
      #PM.test.all[,ID[length(ID)],drop=FALSE]
      
      #PM.test.all[c("Accuracy","Kappa","F1","Precision","Recall"),]
      ACC=cbind(ACC,as.matrix(PM.test.all[ID,]))
      
      } #end of j loop for ACC
      for (k in 1:ncol(ACC)) {ACC[,k][is.na(ACC)[,k]]=0}
colnames(ACC)=c("glm","svm", "rpart","rf")
rownames(ACC)=gsub(rownames(ACC),pattern="LX",replacement="Lag")

#savedFile=paste0("./output/plots/",ID,"_",c("rawData", "ICA", "PCA_corr","PCA_cov")[d])
#png(file = savedFile,width = 664, height = 664, res=100)
#par(mar=c(5.1,4.1,0.5,2.1))
COLOR=heat.colors(100) #COLOR=cm.colors(256) #levelplot(t(ACC),col.regions=COLOR,width=5)
x <- heatmap.2(ACC, col=COLOR,main=MAIN,xlab=XLAB,ylab="Specifications of input variables",
             RowSideColors = cm.colors(nrow(ACC)), ColSideColors = cm.colors(ncol(ACC)),
             margins = c(8,6),symkey=FALSE, density.info="none", trace="none",
             key.xlab=NA,keysize = 1.2,
             key.par=list(mgp=c(1.5, 0.5, 0),
                          mar=c(3, 2.5, 3, 0)))
dev.off() 












if (FALSE) {
  dev.new();heatmap.2(ACC, col=COLOR,main=MAIN,xlab=XLAB,ylab="Specifications of input variables",
                  RowSideColors = cm.colors(nrow(ACC)), ColSideColors = cm.colors(ncol(ACC)),
                  margins = c(8,6),symkey=FALSE, density.info="none", trace="none",
                  key.xlab=NA,keysize = 1.2,
                  key.par=list(mgp=c(1.5, 0.5, 0),
                               mar=c(3, 2.5, 3, 0)))

}






#dev.new();heatmap(ACC, scale = "column",col=COLOR,main="Performance index:Kappa",xlab="model",ylab="Specifications",
#                    RowSideColors = rainbow(nrow(ACC)), ColSideColors = rainbow(ncol(ACC)),margins = c(8,6))

#dev.new();heatmap(ACC,Rowv = NA, RowSideColors = terrain.colors(nrow(ACC)), ColSideColors = rainbow(ncol(ACC)),scale = "column")






















# The mtcars dataset:
data <- as.matrix(mtcars)
# Default Heatmap
heatmap(data, col = terrain.colors(256))

# Use 'scale' to normalize
heatmap(data, scale="column")
# No dendrogram nor reordering for neither column or row
heatmap(data, Colv = NA, Rowv = NA, scale="column")
heatmap(data, Colv = NA, scale="column")

library("lattice")
# Dummy data
x <- seq(1,10, length.out=20)
y <- seq(1,10, length.out=20)
data <- expand.grid(X=x, Y=y)
data$Z <- runif(400, 0, 5)

## Try it out
levelplot(Z ~ X*Y, data=data  ,xlab="X",
          main="")

# Load the library
library("lattice")

# Dummy data
data <- matrix(runif(100, 0, 5) , 10 , 10)
colnames(data) <- letters[c(1:10)]
rownames(data) <- paste( rep("row",10) , c(1:10) , sep=" ")

# plot it flipping the axis
levelplot(data,pretty =T)
levelplot(t(data),pretty =T)
levelplot(t(data),col.regions=heat.colors(100))
levelplot(t(data))





library(ggplot2)

# Dummy data
x <- LETTERS[1:5]
y <- paste0("var", seq(1,20))
data <- expand.grid(X=x, Y=y)
data$Z <- runif(100, 0, 5)

# Heatmap 
ggplot(data, aes(X, Y, fill= Z)) + 
  geom_tile()


library(hrbrthemes)
ggplot(data, aes(X, Y, fill= Z)) + 
  geom_tile() +
  scale_fill_gradient(low="white", high="blue") +
  theme_ipsum()

# Color Brewer palette
ggplot(data, aes(X, Y, fill= Z)) + 
  geom_tile() +
  scale_fill_distiller(palette = "RdPu") +
  theme_ipsum()

# Color Brewer palette
library(viridis)
ggplot(data, aes(X, Y, fill= Z)) + 
  geom_tile() +
  scale_fill_viridis(discrete=FALSE) +
  theme_ipsum()



