outputPath="./output/data/"
source("./src/rollingWindows.R")
library(caret)
library(timeSeries)
y0=paste0("transition",c(0,2:4))[1]
y2=paste0("transition",c(0,2:4))[2]
y3=paste0("transition",c(0,2:4))[3]
y4=paste0("transition",c(0,2:4))[4]
load("./data/Components.RData")
#D=1;m=1;Type=1
data.name=c("ICA","PCA.corr","PCA.noCorr")[D]
dir=c("glm","rpart","svmRadial","rf")[m]
TYPE=c("none","season_trend")[Type] # Whether season and trend are specified

if (data.name=="PCA.noCorr") {no.CA=4} else if (data.name=="PCA.Corr") {no.CA=10
    } else {no.CA=20}  #number of components
usedData0=eval(parse(text = data.name))
usedData=cbind(usedData0[,y0],usedData0[,-c(1:4)][,1:no.CA])


p=6
timeID=time(usedData)[-c(1:p)]
embedY=as.timeSeries(embed(usedData[,1,drop=F],p+1),timeID)
ar.names=paste0("LY",1:p)
arx=embedY[,-1]
colnames(arx)=ar.names
dim(usedData)

embedX=as.timeSeries(embed(usedData[,-1],p+1)[,-c(1:no.CA)],timeID)
LX.names=c(outer(paste0(colnames(usedData)[-1],"_L"),1:p,FUN=paste0))
colnames(embedX)=LX.names

dep=embedY[,1]



Future.all=PM.train.all=PM.test.all=NULL#L=1;t0=1
for (L in 1:p) {#L=1

    LX.ID=grep(LX.names,pattern=paste0("L",L))
    LX.simpleID=paste0("LX",L)
    LX=embedX[,LX.ID] #Extract X variables
    
    trend=seq(nrow(LX))
    y1=as.numeric(substr(as.character(start(LX[,1])),1,4))
    m1=as.numeric(substr(as.character(start(LX[,1])),6,7))
    seasonD=forecast::seasonaldummy(ts(LX[,1],start=c(y1,m1),frequency=12))

    trend=seq(nrow(LX))
    y1=as.numeric(substr(as.character(start(LX[,1])),1,4))
    m1=as.numeric(substr(as.character(start(LX[,1])),6,7))
    seasonD=forecast::seasonaldummy(ts(LX[,1],start=c(y1,m1),frequency=12))
    if (TYPE=="none") {    
      newData=cbind(y=dep,LX)
    } else { newData=cbind(y=dep,LX,trend=trend,seasonD=seasonD)}

    newData0=window(newData,start=start(newData),end="2016-02-01")
    newData1=window(newData,start="2016-03-01",end=end(newData))
    
    head(newData0,3);tail(newData0,3); dim(newData0)
###==========================================

Formula=as.formula("y~ .")
timeframe=rollingWindows(newData0,period="218m",by="25m")
FROM=timeframe$from  
TO=timeframe$to

  Future_byT=PM.train_byT=PM.test_byT=NULL; predData_byT=list()
  for (t0 in 1:length(TO)) {#t0=4

  COLNAMES=paste0(LX.simpleID,"_t",t0)
  trainData0=window(newData0,start=FROM[1],end=TO[t0])

  if(t0==length(TO)) {
  testData0=window(newData0,start=TO[t0],end=end(newData0))[-1,]
      } else {testData0=window(newData0,start=TO[t0],end=TO[t0+1])}

  if (nrow(testData0)<25) {next}
  
  trainData=as.data.frame(unclass(trainData0))
  testData=as.data.frame(unclass(testData0))
  
  trainData$y=as.factor(trainData$y)
  testData$y=as.factor(testData$y)
  

  output=train(Formula, data=trainData, method=dir,tuneLength = 10)


  ##Predict train data
  Pred1 =as.integer(predict(output,trainData,type=c("raw","prob")[1]))-1

  if (sum(Pred1)==0 || sum(Pred1)==length(Pred1)) {Pred1[length(Pred1)]=1-Pred1[length(Pred1)]}
  CFMatrix1=table(actual = trainData[,"y"], predicted =as.factor(Pred1))  #Confusion matrix
  confusionMatrix(CFMatrix1)
  
  ##Predict test data
  Pred2 =as.integer(predict(output,testData,type=c("raw","prob")[1]))-1
  
  if (sum(Pred2)==0 || sum(Pred2)==length(Pred2)) {Pred2[length(Pred2)]=1-Pred2[length(Pred2)]}
  
  actual=as.integer(testData[,"y"])-1
  
  if (sum(actual)==0 || sum(actual)==length(actual)) {actual[length(actual)]=1-actual[length(actual)]}
    CFMatrix2=table(actual = actual, predicted =as.factor(Pred2))  #Confusion matrix
  
  confusionMatrix(CFMatrix2)

  
  PM.train0=round(rbind(as.matrix(confusionMatrix(CFMatrix1),what="overall"),
                        as.matrix(confusionMatrix(CFMatrix1),what="classes")),3)
  colnames(PM.train0)=COLNAMES
  PM.train_byT=cbind(PM.train_byT,PM.train0)
  
  PM.test0=round(rbind(as.matrix(confusionMatrix(CFMatrix2),what="overall"),
                       as.matrix(confusionMatrix(CFMatrix2),what="classes")),3)
  colnames(PM.test0)=COLNAMES
  PM.test_byT=cbind(PM.test_byT,PM.test0)
  
  predData0=data.frame(actual = testData[,"y"], predict =as.factor(Pred2))
  rownames(predData0)=as.character(time(testData0))
  predData_byT[[t0]]=predData0
  
  print(paste0(output$method," ",TYPE," ",COLNAMES))
  
  future =as.integer(predict(output,newData1,type=c("raw","prob")[1]))-1
  future=as.timeSeries(future,time(newData1))
  colnames(future)=COLNAMES
  Future_byT=cbind(Future_byT,future)
  
  } #End of t0 loop for rolling
  
  
  savedRData_byT=paste0(outputPath,data.name,"/",output$method,"/",TYPE,"/",LX.simpleID,".RData")
  savedRData.all=paste0(outputPath,data.name,"/",output$method,"/",TYPE,"/","_PM_all.RData")
  
  save(Future_byT,PM.train_byT,PM.test_byT,predData_byT,file=savedRData_byT)
  
  PM.train.all=cbind(PM.train.all,PM.train_byT)
  PM.test.all=cbind(PM.test.all,PM.test_byT)
  Future.all=cbind(Future.all,Future_byT)
  
}; save(PM.train.all,PM.test.all,Future.all,file=savedRData.all) #End of L loop



