dat=read.csv("./data/AlbumSales.csv")
head(dat)
eq1=as.formula(Sales~Adv)

#Part 1
output1=lm(eq1,data=dat)
summary(output1)
errors=output1$residuals

sqrt(mean(errors^2))
mean(abs(errors))
mean(abs(errors/dat$Sales))

#Part 2.
ID = seq(nrow(dat))
k = 10
fold =sample(rep(1:k, length.out = nrow(dat)))

cv.errors=NULL
for (i in 1:k) { #i=1
  
  validSet = ID[fold == i]
  trainSet = ID[fold != i]
  trainmodel = lm(eq1, data=dat[trainSet,])
  test.fit= predict(trainmodel,newdata=dat[validSet,])
  test.errors=dat[validSet,1]-test.fit
  
  cv.errors=c(cv.errors,test.errors)
  
}
cv.errors1=cv.errors[order(as.integer(names(cv.errors)))]

sqrt(mean(cv.errors1^2))
mean(abs(cv.errors1))
mean(abs(cv.errors1/dat$Sales))

#Part 3
library(caret)
object = train(eq1,data=dat,
                method = "lm",
                tuneLength = 15,
                trControl = trainControl(method = "cv", savePredictions =TRUE))
object$results
names(object)

pred1=object$pred[order(object$pred$rowIndex),]
cv.errors2=pred1[,2]-pred1[,1]
sqrt(mean(cv.errors2^2))
mean(abs(cv.errors2))
mean(abs(cv.errors2/dat$Sales))



dat$vote=as.factor(dat$vote)
dim(dat)
ID=sample(1:2000,1000)
TrainData <- dat[ID,]
newData=dat[-ID,]

object <- train(TrainData[,-1], TrainData[,1],
                method = "glm",
                tuneLength = 10,
                trControl = trainControl(method = "cv"))

A=predict(object,newdata=newData)

B1=predict(glm(vote~.,data=TrainData,family=binomial(logit)),
                           type = "response",newdata=newData)
B=as.factor(ifelse(B1>=0.5,1,0))
names(B)=NULL

identical(A,B)

summary(object)$coef
summary(glm(vote~.,data=TrainData,family="binomial"))$coef






